var search_data = {"index":{"searchIndex":["bliftax","gate","implicant","bit","optimizer","!=()","*()","<<()","==()","==()","[]()","add_implicant()","bit_str()","bits_valid?()","branching()","branching_helper()","cost()","cost()","covers?()","dup()","eql?()","eql?()","get_essential_implicants()","get_prime_implicants()","hash()","hash()","input_size()","make_dummy()","make_null()","minterms()","new()","new()","new()","new()","null?()","optimize()","parse()","parse_bits()","parse_gate()","read_continuous_lines()","sharp()","star()","strip_comments()","strip_trailing_backslash()","to_blif()","to_blif()","to_blif()","to_s()","to_s()"],"longSearchIndex":["bliftax","bliftax::gate","bliftax::implicant","bliftax::implicant::bit","bliftax::optimizer","bliftax::implicant::bit#!=()","bliftax::implicant#*()","bliftax::gate#<<()","bliftax::implicant#==()","bliftax::implicant::bit#==()","bliftax::gate#[]()","bliftax::gate#add_implicant()","bliftax::implicant#bit_str()","bliftax::implicant#bits_valid?()","bliftax::optimizer#branching()","bliftax::optimizer#branching_helper()","bliftax::implicant#cost()","bliftax::optimizer#cost()","bliftax::implicant#covers?()","bliftax#dup()","bliftax::implicant#eql?()","bliftax::implicant::bit#eql?()","bliftax::optimizer#get_essential_implicants()","bliftax::optimizer#get_prime_implicants()","bliftax::implicant#hash()","bliftax::implicant::bit#hash()","bliftax::gate#input_size()","bliftax::implicant::make_dummy()","bliftax::implicant::make_null()","bliftax::implicant#minterms()","bliftax::new()","bliftax::gate::new()","bliftax::implicant::new()","bliftax::implicant::bit::new()","bliftax::implicant#null?()","bliftax::optimizer#optimize()","bliftax#parse()","bliftax::implicant#parse_bits()","bliftax#parse_gate()","bliftax#read_continuous_lines()","bliftax::implicant#sharp()","bliftax::implicant#star()","bliftax#strip_comments()","bliftax#strip_trailing_backslash()","bliftax#to_blif()","bliftax::gate#to_blif()","bliftax::implicant#to_blif()","bliftax::implicant#to_s()","bliftax::implicant::bit#to_s()"],"info":[["Bliftax","","Bliftax.html","","<p>A class that parses a BLIF file.\n"],["Bliftax::Gate","","Bliftax/Gate.html","","<p>Represents one logic gate in the BLIF file\n"],["Bliftax::Implicant","","Bliftax/Implicant.html","","<p>A class that represents an implicant of a gate.\n"],["Bliftax::Implicant::Bit","","Bliftax/Implicant/Bit.html","","<p>A class that represents one bit of an implicant\n"],["Bliftax::Optimizer","","Bliftax/Optimizer.html","","<p>A module that does 2-level logic optimization\n"],["!=","Bliftax::Implicant::Bit","Bliftax/Implicant/Bit.html#method-i-21-3D","(other)","<p>Checks for inequality.\n<p>@param other [Object] whatever to compare against.\n<p>@return [true, false] true if …\n"],["*","Bliftax::Implicant","Bliftax/Implicant.html#method-i-2A","(rhs)",""],["<<","Bliftax::Gate","Bliftax/Gate.html#method-i-3C-3C","(implicant)",""],["==","Bliftax::Implicant","Bliftax/Implicant.html#method-i-3D-3D","(other)","<p>Checks for equality.\n<p>@param other [Object] whatever to compare against\n"],["==","Bliftax::Implicant::Bit","Bliftax/Implicant/Bit.html#method-i-3D-3D","(other)","<p>Checks for equality.\n<p>@param other [Object] whatever to compare against.\n<p>@return [true, false] true if two …\n"],["[]","Bliftax::Gate","Bliftax/Gate.html#method-i-5B-5D","(index)","<p>Returns the specified implicant.\n<p>@param index [Integer] the index of the implicant.\n<p>@return [Implicant] …\n"],["add_implicant","Bliftax::Gate","Bliftax/Gate.html#method-i-add_implicant","(implicant)","<p>Adds an Implicant to this gate.\n<p>@param implicant [Implicant, String, Array&lt;Implicant, String&gt;] the …\n"],["bit_str","Bliftax::Implicant","Bliftax/Implicant.html#method-i-bit_str","(bits)","<p>Returns the BLIF-style representation of this implicant. This method assumes that the output bit is 1 …\n"],["bits_valid?","Bliftax::Implicant","Bliftax/Implicant.html#method-i-bits_valid-3F","(bits)","<p>Checks whether all the bits are either 1, 0, or DC.\n<p>@param bits [Array&lt;String&gt;] the bits to be checked. …\n"],["branching","Bliftax::Optimizer","Bliftax/Optimizer.html#method-i-branching","(to_cover, options)","<p>Finds the minimum-cost combination to cover the given minterms. This method does recursive DFS to search …\n"],["branching_helper","Bliftax::Optimizer","Bliftax/Optimizer.html#method-i-branching_helper","(to_cover, options, implicant)","<p>A helper method for the recursive DFS for branching heuristic.\n<p>@param to_cover [Set&lt;Integer&gt;] minterms …\n"],["cost","Bliftax::Implicant","Bliftax/Implicant.html#method-i-cost","()","<p>Returns the cost of this implicant. A cost refers to the size of the cube, meaning how many don’t-cares …\n"],["cost","Bliftax::Optimizer","Bliftax/Optimizer.html#method-i-cost","(what)","<p>Cost heuristic. If an Implicant is given, the cost of that Implicant is returned. Otherwise, the sum …\n"],["covers?","Bliftax::Implicant","Bliftax/Implicant.html#method-i-covers-3F","(other)","<p>Checks if this implicant covers the given implicant. Implicant a covers b if all bit combinations that …\n"],["dup","Bliftax","Bliftax.html#method-i-dup","()","<p>Duplicates this object.\n<p>@return [Bliftax] the deep copy of this object.\n"],["eql?","Bliftax::Implicant","Bliftax/Implicant.html#method-i-eql-3F","(other)",""],["eql?","Bliftax::Implicant::Bit","Bliftax/Implicant/Bit.html#method-i-eql-3F","(other)",""],["get_essential_implicants","Bliftax::Optimizer","Bliftax/Optimizer.html#method-i-get_essential_implicants","(implicants)","<p>Finds the essential implicants of the given set of implicants. This method applies the sharp operation …\n"],["get_prime_implicants","Bliftax::Optimizer","Bliftax/Optimizer.html#method-i-get_prime_implicants","(implicants)","<p>Returns the prime implicants of the given set of implicants. This method successively applies the star …\n"],["hash","Bliftax::Implicant","Bliftax/Implicant.html#method-i-hash","()","<p>Returns the hash value of this instance.\n<p>@return [Integer] the hash value of this instance.\n"],["hash","Bliftax::Implicant::Bit","Bliftax/Implicant/Bit.html#method-i-hash","()","<p>Returns the hash value of this instance.\n<p>@return [Integer] the hash value of this instance.\n"],["input_size","Bliftax::Gate","Bliftax/Gate.html#method-i-input_size","()","<p>Returns the size of the inputs.\n<p>@return [Integer] the size of the inputs.\n"],["make_dummy","Bliftax::Implicant","Bliftax/Implicant.html#method-c-make_dummy","(inputs, output = '1')","<p>Creates a dummy implicant with the given inputs. This is useful when checking if an implicant is equal …\n"],["make_null","Bliftax::Implicant","Bliftax/Implicant.html#method-c-make_null","()","<p>Creates a new NULL Implicant.\n<p>@return [Implicant] a null Implicant\n"],["minterms","Bliftax::Implicant","Bliftax/Implicant.html#method-i-minterms","()","<p>Finds the possible minterms that this implicant can represent. For example, a bit string of 101 can only …\n"],["new","Bliftax","Bliftax.html#method-c-new","(str = nil)","<p>Initializes the object.\n<p>@param str [String] filename or text to parse.\n"],["new","Bliftax::Gate","Bliftax/Gate.html#method-c-new","(labels)","<p>Initializes this gate with the labels for inputs and output.\n<p>@param labels [Array] the label names for …\n"],["new","Bliftax::Implicant","Bliftax/Implicant.html#method-c-new","(input_labels, output_label, str, is_null = false)",""],["new","Bliftax::Implicant::Bit","Bliftax/Implicant/Bit.html#method-c-new","(label, bit, type)","<p>Creates a new Bit instance.\n<p>@param label [String] the label corresponding to this bit. @param bit [String] …\n"],["null?","Bliftax::Implicant","Bliftax/Implicant.html#method-i-null-3F","()",""],["optimize","Bliftax::Optimizer","Bliftax/Optimizer.html#method-i-optimize","(gate)","<p>Does 2-level logic optimization to the given gate (a set of implicants). This is done in the following …\n"],["parse","Bliftax","Bliftax.html#method-i-parse","(str)","<p>Parses a BLIF file.\n<p>@param str [String] filename or the text to parse.\n<p>@return [Bliftax] the parsed BLIF …\n"],["parse_bits","Bliftax::Implicant","Bliftax/Implicant.html#method-i-parse_bits","(str)","<p>Parses the bit string and returns the bits for inputs and outputs.\n<p>@param str [String] the string representation …\n"],["parse_gate","Bliftax","Bliftax.html#method-i-parse_gate","(labels, lines, i)","<p>Parse one gate from the input.\n<p>@param labels [Array&lt;String&gt;] labels of the inputs and output. @param …\n"],["read_continuous_lines","Bliftax","Bliftax.html#method-i-read_continuous_lines","(fh)","<p>Reads in the BLIF file creating an Array with each element being the logical line (removing comments …\n"],["sharp","Bliftax::Implicant","Bliftax/Implicant.html#method-i-sharp","(rhs)","<p>The Sharp-operator. Described in Chapter 4.10.1 in the Fundamentals of Digital Logic with Verilog Design …\n"],["star","Bliftax::Implicant","Bliftax/Implicant.html#method-i-star","(rhs)","<p>The Star-operator. As described in Chapter 4.10 in the Fundamentals of Digital Logic with Verilog Design …\n"],["strip_comments","Bliftax","Bliftax.html#method-i-strip_comments","(str)","<p>Removes the trailing comments from a string.\n<p>@param str [String] the original string.\n<p>@return [String] …\n"],["strip_trailing_backslash","Bliftax","Bliftax.html#method-i-strip_trailing_backslash","(str)","<p>Removes the trailing backslash from a string.\n<p>@param str [String] the original string.\n<p>@return [String] …\n"],["to_blif","Bliftax","Bliftax.html#method-i-to_blif","()","<p>Returns a string representation of this gate in BLIF format.\n<p>@return [String] this gate in BLIF format. …\n"],["to_blif","Bliftax::Gate","Bliftax/Gate.html#method-i-to_blif","()","<p>Returns a string representation of this gate in BLIF format.\n<p>@return [String] this gate in BLIF format. …\n"],["to_blif","Bliftax::Implicant","Bliftax/Implicant.html#method-i-to_blif","()","<p>Returns the string representation of this implicant.\n<p>@return [String] the string representation of this …\n"],["to_s","Bliftax::Implicant","Bliftax/Implicant.html#method-i-to_s","(show = [:input])","<p>Return the string version of this implicant.\n<p>@param show [:input, :output, :labels, Array&lt;:input, :output, …\n"],["to_s","Bliftax::Implicant::Bit","Bliftax/Implicant/Bit.html#method-i-to_s","()","<p>Return the string version of this bit.\n<p>@return [String] string representation of this bit.\n"]]}}